Development
  • Guides
  • API Reference
  • API Explorer
  • SDKs
  • Sample apps
  • System status
Support
  • Developer forums
  • Developer blog
  • YouTube
  • X
More
  • Square Home
  • Square Developer
  • App Marketplace
  • Partner with Square
  • Solutions Partner Program
  • Pricing
  • Sales

© 2026 Square, Inc.

  • Developer terms of service
  • Developer Integration and Marketing Agreement
  • Privacy policy
  • Partnerships
  • Sign In
  • Sign In

    Catalog

  • Batch delete catalog objects

  • Batch retrieve catalog objects

  • Batch upsert catalog objects

  • Create catalog image

  • Update catalog image

  • Catalog info

  • List catalog

  • Upsert catalog object

  • Delete catalog object

  • Retrieve catalog object

  • Search catalog objects

  • Search catalog items

  • Update item modifier lists

  • Update item taxes

  • Webhooks

  • catalog.version.updated

<- Catalog API

Catalog API

All versions ->

Batch retrieve catalog objects

POST

 /v2/catalog/batch-retrieve

Returns a set of objects based on the provided ID.

Each CatalogItem returned in the set includes all of its child information including: all of its CatalogItemVariation objects, references to its CatalogModifierList objects, and the ids of any CatalogTax objects that apply to it.

Permissions:ITEMS_READ
Try in API Explorer
Link to section

Request body

Example code

Link to section

object_ids

string [ ]

Required

The IDs of the CatalogObjects to be retrieved.

Min Length
1
Max Length
1000
Link to section

include_related_objects

boolean

If true, the response will include additional objects that are related to the requested objects. Related objects are defined as any objects referenced by ID by the results in the objects field of the response. These objects are put in the related_objects field. Setting this to true is helpful when the objects are needed for immediate display to a user. This process only goes one level deep. Objects referenced by the related objects will not be included. For example,

if the objects field of the response contains a CatalogItem, its associated CatalogCategory objects, CatalogTax objects, CatalogImage objects and CatalogModifierLists will be returned in the related_objects field of the response. If the objects field of the response contains a CatalogItemVariation, its parent CatalogItem will be returned in the related_objects field of the response.

Default value: false

Link to section

catalog_version

integer(64-bit)

Beta

The specific version of the catalog objects to be included in the response. This allows you to retrieve historical versions of objects. The specified version value is matched against the CatalogObjects' version attribute. If not included, results will be from the current version of the catalog.

Link to section

include_deleted_objects

boolean

Indicates whether to include (true) or not (false) in the response deleted objects, namely, those with the is_deleted attribute set to true.

Link to section

include_category_path_to_root

boolean

Specifies whether or not to include the path_to_root list for each returned category instance. The path_to_root list consists of CategoryPathToRootNode objects and specifies the path that starts with the immediate parent category of the returned category and ends with its root category. If the returned category is a top-level category, the path_to_root list is empty and is not returned in the response payload.

Link to section

include_options

Beta

Options to include related resources in the response.

Link to section

Response fields

Link to section

errors

Any errors that occurred during the request.

Link to section

objects

A list of CatalogObjects returned.

Link to section

related_objects

A list of CatalogObjects referenced by the object in the objects field.

Link to section

included_resources

Beta

A list of CatalogObjects referenced by the object in the objects field and specifically requested.

Link to section

Examples

All versions ->

POST /v2/catalog/batch-retrieve
curl https://connect.squareup.com/v2/catalog/batch-retrieve \ -X POST \ -H 'Square-Version: 2026-11-18' \ -H 'Authorization: Bearer ACCESS_TOKEN' \ -H 'Content-Type: application/json' \ -d '{ "object_ids": [ "W62UWFY35CWMYGVWK6TWJDNI", "AA27W3M2GGTF3H6AVPNB77CK" ], "include_related_objects": true }'

Response JSON

{ "objects": [ { "type": "ITEM", "id": "W62UWFY35CWMYGVWK6TWJDNI", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "item_data": { "name": "Tea", "description": "Hot Leaf Juice", "categories": [ { "id": "BJNQCF2FJ6S6UIDT65ABHLRX", "ordinal": 0 } ], "tax_ids": [ "HURXQOOAIC4IZSI2BEXQRYFY" ], "variations": [ { "type": "ITEM_VARIATION", "id": "2TZFAOHWGG7PAK2QEXWYPZSP", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "item_variation_data": { "item_id": "W62UWFY35CWMYGVWK6TWJDNI", "name": "Mug", "ordinal": 0, "pricing_type": "FIXED_PRICING", "price_money": { "amount": 150, "currency": "USD" } } } ] } }, { "type": "ITEM", "id": "AA27W3M2GGTF3H6AVPNB77CK", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "item_data": { "name": "Coffee", "description": "Hot Bean Juice", "categories": [ { "id": "BJNQCF2FJ6S6UIDT65ABHLRX", "ordinal": 0 } ], "tax_ids": [ "HURXQOOAIC4IZSI2BEXQRYFY" ], "variations": [ { "type": "ITEM_VARIATION", "id": "LBTYIHNHU52WOIHWT7SNRIYH", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "item_variation_data": { "item_id": "AA27W3M2GGTF3H6AVPNB77CK", "name": "Regular", "ordinal": 0, "pricing_type": "FIXED_PRICING", "price_money": { "amount": 250, "currency": "USD" } } }, { "type": "ITEM_VARIATION", "id": "PKYIC7HGGKW5CYVSCVDEIMHY", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "item_variation_data": { "item_id": "AA27W3M2GGTF3H6AVPNB77CK", "name": "Large", "ordinal": 1, "pricing_type": "FIXED_PRICING", "price_money": { "amount": 350, "currency": "USD" } } } ] } } ], "related_objects": [ { "type": "CATEGORY", "id": "BJNQCF2FJ6S6UIDT65ABHLRX", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "category_data": { "name": "Beverages" } }, { "type": "TAX", "id": "HURXQOOAIC4IZSI2BEXQRYFY", "updated_at": "2016-11-16T22:25:24.878Z", "version": 1479335124878, "is_deleted": false, "present_at_all_locations": true, "tax_data": { "name": "Sales Tax", "calculation_phase": "TAX_SUBTOTAL_PHASE", "inclusion_type": "ADDITIVE", "percentage": "5.0", "enabled": true } } ] }